//		  Ŀ
//	> AVNER 
//	>  BEN  > Software Engineering Method
//		  
//	10 Dov-Hoz st. Tel-Aviv 63416 Israel tel. 972-3-221535

// The Screen NAVigator, ver 1.20 August 1990
// Copyright (c) 1990 by Avner Ben
// Snav is not, and never was, free software.
// for conditions for use refer to file "copyrigh.txt"

// The Screen Navigator is an object-oriented device-independent
// character-graphics driver package, written in the C++ language,
// distributed in the form of C++ source code.
// For further information refer to the documentation files.

// this simple example is intended as a template to be extended and modified
// by the user, provided the above title and copyright notice are unchanged
// and are not ommitted.

/***************************************************************************/

// demonstration part 2 - source code.
// a simplistic formatted-input driver, implemented with the screen driver
// of demo part 1. Device-specific assumptions made about function key
// values. Implemented are only the methods required by the main demo program.

// 28.10.89 avner ben coded.
// 13.7.90  last update by avner ben.

// site history (this copy):
// __.__.__, _____________: _______________________________.

#include <conio.h>
#include <ctype.h>
#ifndef SNAV2_H
#include "/mtad/snav/snav2.hpp"
#endif
#include "demo2.hpp"

extern screen_driver_manager screen_driver;
extern keyboard_driver_manager keyboard_driver;

character_input :: character_input(panel *inscr)
{
	private_screen=FALSE;
	scr=inscr;
	cc=' '; fkey=K_C;
}

character_input :: character_input(square_pos &window, int driver_num)
{
	private_screen=TRUE;
	scr=screen_driver.allocate(window,driver_num);
	cc=' '; fkey=K_C;
}

character_input :: ~character_input()
{
	if (private_screen) delete scr;
}

boolean character_input :: get_position(char * prompt, panel *drawbd, boolean hilite)
{
	if (*prompt)
		{ clear(); scr->put_s(prompt); }
	drawbd->posit();
	while (get_c()!='\r') {
		if (fkey) switch (fkey) {
			case K_ESC:  clear(); return(FALSE);
			case K_RT :  drawbd->move(&rt); break;
			case K_UP :  drawbd->move(&up); break;
			case K_LT :  drawbd->move(&lt); break;
			case K_DN :  drawbd->move(&dn); break;
		}
	}
	if (hilite) drawbd->put_attr(VD_REV);
	clear();
	return(TRUE);
}

int character_input :: get_number(char *prompt, int imax)
{
	scr->put_s(prompt); move();
	int i=0;
	while (isdigit(get_c()) || i==0) {
		if (fkey==K_ESC) return(0);
		if (isdigit(cc) && i*10+charnum(cc)<=imax) {
			i=i*10+charnum(cc);
			scr->put_c(cc);
			if (i*10>imax) break;
		}
	}
	return(i);
}

direction& character_input :: get_dir()
{
	static direction result;
	result=direction(NODIR);
	scr->put_s("direction (arrw):"); move();
	while (!result()) {
		get_c();
		switch (fkey) {
			case K_RT :	 result=rt; break;
			case K_UP :	 result=up; break;
			case K_LT :	 result=lt; break;
			case K_DN :	 result=dn; break;
		}
	}
	scr->put_s(result.name());
	return result;
}

weight_d& character_input :: get_wgt()
{
	static weight_d result;
	scr->put_s("weight (h:v):"); move();
	int i[2];
	for (int j=0; j<=1; j++) {
		put_c_stay('1');
		while (get_c()!='\r')
			if (cc>='0' && cc<='3') break;
		if (cc=='\r') cc='1';
		i[j]=charnum(cc);
		scr->put_c(cc);
		if (j<1) scr->put_c(':');
	}
	result=weight_d(i[0],i[1]);
	return result;
}

boolean character_input :: get_boolean(char *prompt)
{
	scr->put_s(prompt); move();
	put_c_stay('Y');
	for (get_c(); ; get_c())
		if (cc=='Y' || cc=='y' || cc=='\r') {
			scr->put_c('Y'); return(TRUE);
		} else if (cc=='N' || cc=='n') {
			scr->put_c('N'); return(FALSE);
		}
}

void character_input :: msg(char *prompt)
{
	clear();
	scr->put_s(prompt); get_c();
	clear();
}

character_input *keyboard_driver_manager :: allocate(square_pos &window,
 int scr_num, int kbd_num)
{
	if (!kbd_num) kbd_num=default_kbd;

	switch (kbd_num) {
		case 1 : return new pc_keyboard((square_pos)window, scr_num);
		// insert here other drivers you may have...
		default: return new pc_keyboard((square_pos)window, scr_num);
		// installation default
	}
}

character_input *keyboard_driver_manager :: allocate(panel *scr, int kbd_num)
{
	if (!kbd_num) kbd_num=default_kbd;

	switch (kbd_num) {
		case 1 : return new pc_keyboard(scr);
		// insert here other drivers you may have...
		default: return new pc_keyboard(scr);
		// installation default
	}
}

char pc_keyboard :: get_c()
{ // device-specific primitive
  // the only module in system allowed to make physical input.
  // the reserved word "getch()" is reminded only twice, and both are here.

	if (!(cc=getch())) {			     // pc-specific scan-codes
		cc=' ';
		switch ((cc=getch())) {
			case 'M' :  fkey=K_RT; break;
			case 'H' :  fkey=K_UP; break;
			case 'K' :  fkey=K_LT; break;
			case 'P' :  fkey=K_DN; break;
		}
	} else if (cc=='\033') {
		cc=' '; fkey=K_ESC;
	}
	else fkey=K_C;
	return cc;
}

int pc_keyboard :: charnum(char c)
{ // not counting on the standard library!

	if (c<'0' || c>'9') return 0;
	return (int)(c-'0');
}

slide_option :: slide_option(char *text, int posopt, char *help)
{
	s=new char[strlen(text)+1]; strcpy(s,text);
	hlp=new char[strlen(help)+1]; strcpy(hlp,help);
	// convert all but option char to lower-case
	if (posopt<1 || posopt>strlen(text)) posopt=1; posopt-=1;
	letter=s+posopt;
	for (int i=strlen(text)-1; i>=0; i--)
		if (i==posopt) s[i]=toupper(s[i]);
		else s[i]=tolower(s[i]);
	num=0;
	suc=prd=NULL;
}

slide_menu :: slide_menu(panel *parent, character_input *help)
{ // chops top line off parent screen!
	scr=screen_driver.allocate(parent->ask_window());
	scr->set_limit(up,parent->ask_limit(up));
	parent->move_limit(up,-1);
	explain=help;
	stopt=enopt=cursor=NULL;
	scr->clear();
}

slide_menu :: ~slide_menu(void)
{
	delete(scr);
	if (stopt) {
		slide_option *suc=stopt->suc;
		for (; stopt; stopt=suc) {
			suc=stopt->suc;
			delete(stopt);
		}
	}
}

void slide_menu :: append_opt(char *text, int posopt, char *help)
{
	if (!*text) return;
	enopt=new slide_option(text, posopt, help);
	if (!stopt) {
		cursor=stopt=enopt;
		enopt->pos=scr->ask_corner(up);
		scr->put_c('',&(enopt->pos)); (enopt->pos).move(rt);
		enopt->num=1;
	} else {
		for (slide_option *opt0=stopt; opt0->suc; opt0=opt0->suc) ;
		opt0->suc=enopt; enopt->prd=opt0;
		enopt->num=opt0->num+1;
		enopt->pos=opt0->pos;
		(enopt->pos).move(rt,strlen(opt0->s)+1);
	}
	enopt->on(scr);
	point_pos pt=enopt->pos;
	pt.move(rt,strlen(enopt->s));
	scr->put_c('',&pt);
	pt.move(rt);
	if (!scr->get_attr(VD_REV,&pt))
		while (scr->ask_legal(&pt)) {
			scr->put_attr(VD_REV,&pt); pt.move(rt);
		}
}

void slide_menu :: succ_opt()
{
	if (!stopt) return;
	cursor->on(scr);
	if (cursor->suc) cursor=cursor->suc;
	else cursor=stopt;
	cursor->off(scr); cursor->put_help(explain);
}

void slide_menu :: pred_opt()
{
	if (!stopt) return;
	cursor->on(scr);
	if (cursor->prd) cursor=cursor->prd;
	else cursor=enopt;
	cursor->off(scr); cursor->put_help(explain);
}

int slide_menu :: select()
{
	if (!stopt) return 0;
	if (!stopt->suc) return 1;
	cursor->off(scr); cursor->put_help(explain);
	while (explain->get_c()!='\r') {
		if (explain->fk()==K_ESC) return 0;
		else if (explain->fk()==K_RT) succ_opt();
		else if (explain->fk()==K_LT) pred_opt();
		else {
			char c=toupper(explain->c());
			for (slide_option *opt=stopt; opt; opt=opt->suc)
				if (*(opt->letter)==c) {
					cursor->on(scr);
					cursor=opt; cursor->off(scr);
					cursor->put_help(explain);
					break;
				}
			if (c==*(cursor->letter)) break; // auto select
		}
	}
	explain->clear();
	return cursor->num;
}

text_window :: text_window(panel *parent, point_pos *pt0, char *title, boolean centered, char *inpline[])
{
	point_pos start;
	if (pt0 && parent->ask_legal(pt0)) start=*pt0;
	else {
		start.sety(parent->ask_limit(up));
		start.setx(parent->ask_limit(lt));
	}
	int len=0;
	for (int numlns=0; inpline[numlns][0]; numlns++)
		if (strlen(inpline[numlns])>len)
			len=strlen(inpline[numlns]);
	if (len+start.x()-1+2>parent->ask_limit(rt))
		len=parent->ask_limit(rt)-start.x()+1-2;
	if (numlns+start.y()-1+2>parent->ask_limit(dn))
		len=parent->ask_limit(dn)-start.y()+1-2;
	box=screen_driver.allocate(square_pos(start,
	 point_pos(start.y()+numlns-1+2,start.x()+len-1+2)));
	box->save();
	box->toggle_attr(VD_HI);
	box->enframe(h2v1,title,centered);
	box->toggle_attr(VD_HI);
	kbd=keyboard_driver.allocate(box);
	point_pos pos=box->ask_corner(up);
	for (int i=0; i<numlns; i++) {
		box->posit(&pos);
		box->put_s(inpline[i]);
		pos.move(dn);
	}
}

void text_window :: pause(char *prompt)
{
	if (*prompt) {
		box->move_limit(dn,1);
		point_pos stpos(box->ask_limit(dn),box->ask_limit(lt));
		char c=box->get_c(&stpos);
		weight_d wgt=alph->cweight(c);
		int col=box->ask_limit(rt)-strlen(prompt)+1;
		box->reset_color();
		if (col>=box->ask_limit(lt))
			box->put_s(prompt,&point_pos(box->ask_limit(dn),col));
		else box->put_s(prompt,&stpos);
		kbd->get_c();
		box->toggle_attr(VD_HI);
		box->arclist(&stpos,box->ask_len(hdim),rt,wgt);
		box->move_limit(dn,-1);
		box->toggle_attr(VD_HI);
	} else kbd->get_c();
}

void text_window :: put_page(char *inpline[])
{
	box->clear();
	for (int numlns=0; inpline[numlns][0]; numlns++) ;
	point_pos pos(box->ask_limit(up),box->ask_limit(lt));
	for (int i=0; i<numlns; i++) {
		box->posit(&pos);
		box->put_s(inpline[i]);
		pos.move(dn);
	}
}
